
PrefabFiles = {
	"broccoli",        
    "gemma",           
    "auraringfx",      
    --"broccoli_none",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/broccoli.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/broccoli.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/broccoli.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/broccoli.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/broccoli_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/broccoli_silho.xml" ),

    Asset( "IMAGE", "bigportraits/broccoli.tex" ),
    Asset( "ATLAS", "bigportraits/broccoli.xml" ),
	
	Asset( "IMAGE", "images/map_icons/broccoli.tex" ),
	Asset( "ATLAS", "images/map_icons/broccoli.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_broccoli.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_broccoli.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_broccoli.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_broccoli.xml" ),
	
    Asset("SOUNDPACKAGE", "sound/broccoli.fev"),
	Asset("SOUND", "sound/broccoli.fsb"),
	
	Asset( "IMAGE", "bigportraits/broccoli_none.tex" ),
    Asset( "ATLAS", "bigportraits/broccoli_none.xml" ),
	
	Asset( "IMAGE", "images/names_broccoli.tex" ),
    Asset( "ATLAS", "images/names_broccoli.xml" ),
}

RemapSoundEvent( "dontstarve/characters/broccoli/death_voice", "broccoli/sound/death_voice" )
RemapSoundEvent( "dontstarve/characters/broccoli/hurt", "broccoli/sound/hurt" )
RemapSoundEvent( "dontstarve/characters/broccoli/talk_LP", "broccoli/sound/talk_LP" )

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH
local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe  
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
local SpawnPrefab = GLOBAL.SpawnPrefab
local ActionHandler = GLOBAL.ActionHandler
local TheInput = GLOBAL.TheInput
local Vector3 = GLOBAL.Vector3
local FindEntity =GLOBAL.FindEntity
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local GetWorld = GLOBAL.GetWorld
GLOBAL.TUNING.BROCCOLI = {}
GLOBAL.TUNING.BROCCOLI.KEYFOUR = GetModConfigData("key4") or 122

--local is_shipwrecked = SaveGameIndex:IsModeShipwrecked()



local function BroccoliballFn(inst)
--if inst:HasTag("playerghost") then return end 
if inst.transformed then
inst.AnimState:SetBuild("broccoli")
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/catcoon/pounce")
inst.components.locomotor.walkspeed = (5.5)
inst.components.locomotor.runspeed = (7.5)
inst.components.health.absorb = 0.50           
inst.Transform:SetScale(0.7, 0.7, 0.7)
       if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then 
        inst.components.combat.damagemultiplier = 0.75
       
        elseif not GLOBAL.SaveGameIndex:IsModeShipwrecked() then
        inst.components.combat:AddDamageModifier("broccoli",-0.25)
        
        elseif GLOBAL.SaveGameIndex:IsModeShipwrecked() then
        inst.components.combat:AddDamageModifier("broccoli",-0.25)
         end
 else  
inst.AnimState:SetBuild("broccoliball")
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/catcoon/pounce")
inst.components.locomotor.walkspeed = (6.5 * 1.5)
inst.components.locomotor.runspeed = (8 * 1.5)
inst.components.health.absorb = 0.10
inst.Transform:SetScale(0.7, 0.7, 0.7)
        if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then 
        inst.components.combat.damagemultiplier = 0
        
        elseif not GLOBAL.SaveGameIndex:IsModeShipwrecked() then
        inst.components.combat:AddDamageModifier("broccoli",-1.00)
       
        elseif GLOBAL.SaveGameIndex:IsModeShipwrecked() then
        inst.components.combat:AddDamageModifier("broccoli",-1.00)
	   end

end
 
inst.transformed = not inst.transformed
 
-- inst.components.health:SetCurrentHealth(1)
-- inst.components.health:DoDelta(0)
return true
 
end

 
--AddModRPCHandler("broccoli", "BROCCOLIBALL", BroccoliballFn)
 

 TheInput = GLOBAL.TheInput
 function isKeyDown(key,paused) 
	if not GLOBAL.InGamePlay() then
		return false
	end
	if paused and GLOBAL.IsPaused() then
		return false
	end
	if key then
		if type(key) == 'table' then
			for k,v in ipairs(key) do
				if not TheInput:IsKeyDown(v) then return false end
			end
		else
			if not TheInput:IsKeyDown(key) then return false end
		end
		return true
	end
	return not TheInput:IsKeyDown(GLOBAL.KEY_CTRL) and not TheInput:IsKeyDown(GLOBAL.KEY_SHIFT) and not TheInput:IsKeyDown(GLOBAL.KEY_ALT)
end


TheInput:AddKeyUpHandler(GLOBAL.TUNING.BROCCOLI.KEYFOUR, function()
	if isKeyDown(nil,true) then --
		local player = GLOBAL.GetPlayer()
		if player and player.prefab == 'broccoli' then 
			BroccoliballFn(player) 
		end
	end
end)
 --===========================================================================================
 

local myspeech = require "speech_broccoli"             
 

local function EditSpeech(val)
    if type(val) == "table" then
        for k, v in pairs(val) do
            if type(v) == "table" then
                EditSpeech(v)
            elseif type(v) == "string" then
                val[k] = val[k].." Nyu."
            end
        end
    end
end

EditSpeech(myspeech)


----------------------------------------------------------------------------------------


STRINGS.NAMES.GEMMA = "Gemma, the Yellow Alien Orb thing."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.GEMMA = "Look how yellow and bulbous it is."

-- The character select screen lines
STRINGS.CHARACTER_TITLES.broccoli = "Ҳ    è "
STRINGS.CHARACTER_NAMES.broccoli = "Brocolli"
STRINGS.CHARACTER_DESCRIPTIONS.broccoli = "*  Broccoli\n*   Puchiko!\n*  ô    ?"
STRINGS.CHARACTER_QUOTES.broccoli = "\"      ͸ , nyu.\""

-- Custom speech strings
STRINGS.CHARACTERS.BROCCOLI = require "speech_broccoli"

-- The character's name as appears in-game 
STRINGS.NAMES.BROCCOLI = "Puchi-..Brocolli"

-- The default responses of examining the character
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BROCCOLI = 
{
	GENERIC = "It's Puchi-..Brocolli!",
	ATTACKER = "That Brocolli looks shifty...",
	MURDERER = "Murderer!",
	REVIVER = "Brocolli, friend of ghosts.",
	GHOST = "Brocolli could use a heart.",
}


AddMinimapAtlas("images/map_icons/broccoli.xml")

-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("broccoli", "FEMALE")

